DROP EXTENSION tablefunc;
CREATE EXTENSION tablefunc;
/*
STEP 1
Setup. Create,indexandpopulateworkingtables.
 Y which has all of the dimensions
 http://www2.cs.uh.edu/~ordonez/pdfwww/w-2004-KDD-sqlkm.pdf
*/

CREATE OR REPLACE FUNCTION numClusters()
  RETURNS integer AS $numClusters$
 begin
 	return 4;
	end;
$numClusters$ language plpgsql;

CREATE OR REPLACE FUNCTION numDimensions()
  RETURNS integer AS $numDimensions$
 begin
 	return 2;
	end;
 $numDimensions$ language plpgsql;

CREATE OR REPLACE FUNCTION numIter()
  RETURNS integer AS $numIter$
 begin
 	return 10;
	end;
 $numIter$ language plpgsql;


--Cut out importing into Y
DROP TABLE YH;
DROP TABLE YV;
DROP TABLE W CASCADE;
DROP TABLE R;
DROP TABLE C;
DROP TABLE MODEL;
DROP TABLE YD;
DROP TABLE YNN;

CREATE TABLE YH AS
SELECT sum(1) over (rows unbounded preceding) as i,* FROM data;

CREATE TABLE YV(
  i int,
  l int, -- dimension
  val Float,
  Primary Key(i, l)
);

--instead of insertion - just pivoting
-- if unknown number of clusters - use insertion

INSERT INTO YV
SELECT i, l, val
FROM YH
JOIN LATERAL (VALUES(1, YH.Y1), (2, YH.y2) , (3, YH.y3), (4, YH.y4))--, (5, YH.Y5))--, (6, YH.y6) , (7, YH.y7), (8, YH.y8) , (9, YH.y9), (10, YH.y10))-- dimesnsion increase
    s(l, val) ON true;


CREATE TABLE W(
	j int Primary Key, -- cluster
	w float -- count of points per cluster
);


CREATE TABLE R(
	l int, -- nsion()*
	j int, -- cluster
	val float, --variance
	PRIMARY KEY(l, j)
);


/*
STEP 2
 Initialization. InitializeC
  - Create Center Horizontal
  - Then pivot
*/



CREATE TABLE C(
	l int, -- dimension d
  j int, --  number of clusters k
  val Float,--avg of point in the same cluster
	PRIMARY KEY(l, j)
);


truncate c;
--select * from YV;
--select * from c;
do $$
declare
   lim integer:= numDimensions()*numClusters();
   r record;
begin
    FOR r IN SELECT * FROM YV ORDER BY i LIMIT lim LOOP
       -- RAISE NOTICE 'col1: %, col2: % yv%', r.i, r.l, r.val;
		INSERT INTO C VALUES(r.l, r.i, r.val);

    END LOOP;
end$$;
select * from c order by j;
--ALTER TABLE C ADD PRIMARY KEY (l, j);


Create table model(
	d int,
	k int,
	n int,
	iteration int,
	avg_q float,
	--diff_avg_q float,
	PRIMARY KEY (d, k) --deleted d
);

INSERT INTO model (d, k, iteration) (select l, j, 0 from C);

Create table yd(
			i int, -- number
			j int, --cluster
			distance float,
			primary key(i ,j)
		);

CREATE TABLE YNN(
			i int primary key, --n
			j int -- cluster
		);

do $$
declare
	iter int :=1;
begin
	while iter <= numIter()
	loop
		raise notice 'iteration % Start', iter;
		/*
		STEP 3
		E step. Computekdistancesper pointyi.
		*/

		TRUNCATE YD;


		--raise notice 'iteration % before YD', iter;

		insert into YD
		Select i, j, sum((YV.val-C.val)^2)
		FROM YV, C
		Where YV.l = C.l
		GROUP BY i,j ;

		--raise notice 'iteration % after YD', iter;
		--select * from yd;
		/*
		STEP 4
		E step. FindclosestcentroidCjto each pointyi
		*/

		TRUNCATE YNN;

		INSERT INTO YNN
		SELECT YD.i, YD.j
		FROM YD, (SELECT i, min(distance) AS minDIST
				 FROM YD GROUP BY i) YMIND
		WHERE YD.i = YMIND.i and YD.distance = YMIND.minDist
		---ORDER BY i;
		;
		-- care for abnormal cases
		--select * from YNN order by j;

		/*
		STEP 5
		UpdateW; CandR
		*/
		--W - k weights,
		TRUNCATE w;

		INSERT INTO W
			SELECT j, count(*)
			FROM YNN GROUP BY j;
		--select * from W order by j;

		-- computing points per cluster
		--UPDATE W SET w = w/(select model.n from  model where model.k=w.j) ;
		--select * from w;
		/*
	INSERT INTO model (d, k, n, iteration) (select *, 0 from W)
	ON CONFLICT (d, k) DO UPDATE SET k=excluded.k, n = (select W.w from W where model.k = W.j), iteration =2;
*/

		--INSERT INTO model (d, k, n, iteration) (select *, 0 from W)
		UPDATE MODEL SET n = W.w, iteration = iteration +1 FROM W WHERE k = W.j;
		-- computing avg of points in the same cluster to get new centroids

		TRUNCATE C;
		-- select * from c;

		INSERT INTO C
			SELECT l, j, avg(YV.val)
			FROM YV, YNN
			WHERE YV.i = YNN.i
			GROUP BY l,j;

		-- select l as Dimension, j as Cluster, val as AvgVal from c;

		TRUNCATE R;

		-- calculating variances per cluster
		INSERT INTO R
			SELECT C.l, C.j, avg((YV.val-C.val)^2)
			FROM C, YV, YNN
			WHERE YV.i = YNN.i and YV.l = C.l and YNN.j = C.j
			GROUP BY C.l, C.j;

		-- SELECT * FROM R;
		-- compute variance





		--UPDATEmodelFROM(SELECTsum(WR:val) ASavgqFROMR; WWHERER:j=W:j)avgRSETavgq=avgR:avgq,iteration=iteration+1;
	/*
	WITH AVGR AS (
  	SELECT sum(W*R.val) AS avg_q
		 FROM R,W WHERE R.j = W.j )
	INSERT INTO model SELECT * FROM AVGR;
*/
		UPDATE model
		SET avg_q = C.val FROM C WHERE k = C.j AND d = C.l;

/*
		UPDATE model
		SET avg_q = AVGR.s FROM (SELECT sum(W*R.val) as s, R.j as j, R.l as l
		FROM R,W WHERE R.j = W.j GROUP BY R.j, R.l) AS AVGR WHERE k = AVGR.j AND d = AVGR.l;
*/
		raise notice 'iteration % End', iter;
		iter := iter + 1;
end loop;
end $$;
/*
STEP 6
Updatetableto track K-meansprogress
*/

select * from model order by k, d;
