-- FUNCTION: public.randomForestPredict(regclass, integer)

-- DROP FUNCTION public."randomForestPredict"(regclass, integer);

CREATE OR REPLACE FUNCTION public."randomForestPredict"(
	table_tree regclass,
	"row" integer)
    RETURNS double precision[]
    LANGUAGE 'plpgsql'
    COST 100
    VOLATILE PARALLEL UNSAFE
AS $BODY$
declare
	predictions integer[];
	rowNumber integer;
	idx integer;
	oneRow public."randomTrees"%rowType;
begin
	predictions := array[0,0,0,0,0,0];
	idx := 0;
	for oneRow in
		execute format ('select * from %s', table_tree)
	loop
		if oneRow.left = 1 then
			predictions[idx] := 1;
		else
			predictions[idx] := -1;
		end if;
		idx := idx + 1;
	end loop;
	return predictions;
end;
$BODY$;

ALTER FUNCTION public."randomForestPredict"(regclass, integer)
    OWNER TO postgres;
